        struct TestVector {
            c: [u8; 32],
            pk: [u8; 33],
            address: [u8; 20],
            external_ovk: [u8; 32],
            internal_ovk: [u8; 32],
            account: u32,
        };

        // From https://github.com/zcash-hackworks/zcash-test-vectors/blob/master/bip_0032.py
        let test_vectors = vec![
            TestVector {
                c: [
                    0x9b, 0xa0, 0x43, 0x9c, 0x6a, 0x2d, 0x3d, 0x90, 0x38, 0x83, 0xd4, 0x53, 0x7c, 0x36, 0x22, 0x88, 0x62, 0x6d, 0xa6, 0x2c, 0x62, 0x99, 0x01, 0x2e, 0x36, 0x2d, 0x8f, 0xb6, 0xef, 0xeb, 0xab, 0x47
                ],
                pk: [
                    0x02, 0xed, 0x63, 0x85, 0x32, 0xc4, 0x75, 0xf6, 0x74, 0x00, 0x35, 0x0f, 0xb1, 0xd6, 0xed, 0xa5, 0x59, 0xcd, 0xc2, 0x89, 0xa1, 0x9b, 0x43, 0x19, 0xeb, 0x17, 0x51, 0x40, 0xaa, 0x86, 0x89, 0x38, 0x36
                ],
                address: [
                    0x67, 0x25, 0xf2, 0x62, 0xbb, 0xa6, 0x42, 0x2f, 0xd4, 0x7c, 0x30, 0x5b, 0x83, 0x78, 0xc4, 0x99, 0x42, 0x41, 0xc4, 0x42
                ],
                external_ovk: [
                    0xd4, 0x86, 0x35, 0x2d, 0xd1, 0xd6, 0x66, 0x98, 0xa6, 0x16, 0x34, 0xab, 0x21, 0x9a, 0x2a, 0x6e, 0xa3, 0xc2, 0xee, 0x98, 0x79, 0xcc, 0x82, 0x84, 0x03, 0xba, 0x99, 0x69, 0x50, 0x57, 0x74, 0xdd
                ],
                internal_ovk: [
                    0x73, 0x90, 0xae, 0x2d, 0xf3, 0x1c, 0xee, 0xb2, 0x64, 0xcf, 0xbb, 0xcb, 0xbf, 0xfd, 0x2d, 0x97, 0x3d, 0xb6, 0x8c, 0xf5, 0x72, 0xa7, 0x56, 0xd3, 0x2d, 0x5b, 0xd3, 0xec, 0x00, 0x46, 0x59, 0x7f
                ],
                account: 0,
            },
            TestVector {
                c: [
                    0xfa, 0x92, 0x91, 0xb3, 0x53, 0xbe, 0x21, 0xac, 0x45, 0x2f, 0x85, 0xcb, 0x96, 0xe4, 0xfc, 0x97, 0x8d, 0x35, 0x2e, 0x34, 0xc5, 0xc0, 0x25, 0x9a, 0xc2, 0x8d, 0x0b, 0xea, 0xb1, 0xb8, 0xe2, 0x98
                ],
                pk: [
                    0x03, 0xfc, 0x39, 0x9e, 0x61, 0x3d, 0x01, 0x08, 0x65, 0xd5, 0xa1, 0xfa, 0x87, 0x65, 0xb7, 0x10, 0x9f, 0x9d, 0xb1, 0xed, 0x56, 0x21, 0x89, 0x83, 0xf9, 0xbd, 0x54, 0xb8, 0xc7, 0x12, 0x47, 0x88, 0x29
                ],
                address: [
                    0x04, 0x63, 0x1a, 0xd8, 0x90, 0x2a, 0xd2, 0xfc, 0x56, 0x41, 0xbb, 0xe9, 0x35, 0xde, 0xa6, 0x79, 0x50, 0xbb, 0x9c, 0x59
                ],
                external_ovk: [
                    0xd2, 0xbd, 0x69, 0xa3, 0xd3, 0xe8, 0x25, 0xe3, 0x63, 0x3f, 0x49, 0x7f, 0xc1, 0xb5, 0x04, 0xba, 0xf6, 0x73, 0x29, 0xa9, 0x16, 0x74, 0x87, 0xd0, 0xfd, 0x98, 0xca, 0xe5, 0xd1, 0xa9, 0x66, 0x13
                ],
                internal_ovk: [
                    0xc8, 0x01, 0x85, 0x9b, 0xd2, 0xfb, 0x9f, 0x09, 0x0d, 0x65, 0x18, 0xe1, 0xfe, 0x19, 0x27, 0x84, 0xe7, 0x5a, 0xb7, 0x69, 0xc8, 0xec, 0x66, 0x21, 0xf7, 0xbc, 0x0c, 0x13, 0x20, 0x82, 0x0b, 0x0a
                ],
                account: 1,
            },
            TestVector {
                c: [
                    0xf6, 0xa7, 0x04, 0xfc, 0x09, 0x38, 0x82, 0x16, 0x6a, 0x88, 0xee, 0xb2, 0x43, 0xe2, 0x65, 0x8f, 0x0e, 0xb7, 0xb5, 0xb7, 0x94, 0x3c, 0xe4, 0x7c, 0x39, 0x24, 0xc6, 0x7c, 0x96, 0x47, 0x4c, 0xea
                ],
                pk: [
                    0x02, 0x9f, 0x17, 0x94, 0x89, 0x55, 0x62, 0x43, 0x0d, 0x5d, 0xc8, 0xbe, 0x5e, 0x88, 0xcf, 0xee, 0xe3, 0x26, 0x1d, 0x6b, 0xe4, 0xe6, 0xeb, 0x5b, 0x23, 0x8e, 0xcc, 0x9e, 0x7e, 0xbd, 0xeb, 0x1b, 0xf0
                ],
                address: [
                    0x0b, 0xec, 0x65, 0xaa, 0x3c, 0xf1, 0xaf, 0x84, 0xa9, 0x5d, 0xa1, 0xe6, 0xb9, 0xe4, 0xa5, 0x2b, 0x74, 0x42, 0x8f, 0xf6
                ],
                external_ovk: [
                    0xa6, 0x0c, 0xaa, 0x83, 0x0f, 0x08, 0xd4, 0xa5, 0x4c, 0x39, 0x80, 0x2c, 0x0a, 0xdc, 0x1c, 0x2b, 0xa4, 0x22, 0xce, 0xb8, 0x09, 0x7c, 0xd1, 0x26, 0xa2, 0x08, 0x13, 0xf5, 0x7e, 0x4d, 0x2f, 0x82
                ],
                internal_ovk: [
                    0x14, 0xf5, 0x95, 0x92, 0x21, 0x33, 0x8f, 0x3a, 0xdb, 0x60, 0xdf, 0x69, 0x04, 0x2d, 0xea, 0x7c, 0xfb, 0xd8, 0x72, 0x0c, 0x3f, 0xad, 0x1d, 0xeb, 0xaa, 0x0b, 0xea, 0x81, 0x74, 0xce, 0xa5, 0x6e
                ],
                account: 2,
            },
            TestVector {
                c: [
                    0x3e, 0xbe, 0x46, 0xd6, 0x20, 0x4f, 0xee, 0xb4, 0x3b, 0xd8, 0x35, 0x11, 0xcd, 0x81, 0x61, 0x34, 0xc2, 0xf0, 0x3d, 0x85, 0x82, 0xc6, 0x64, 0x31, 0x8c, 0xc6, 0x00, 0x63, 0xec, 0xa3, 0x8a, 0x04
                ],
                pk: [
                    0x02, 0x0f, 0x8a, 0xed, 0x76, 0x90, 0xbc, 0x84, 0xe3, 0xfa, 0x65, 0x10, 0xc3, 0x62, 0xbb, 0x92, 0x90, 0x90, 0x4b, 0x6f, 0xf5, 0xb7, 0x5e, 0x4e, 0x5c, 0xa6, 0xde, 0x82, 0x1b, 0xf3, 0x38, 0x9f, 0xae
                ],
                address: [
                    0x75, 0x2c, 0x53, 0xa4, 0x3b, 0x8a, 0x44, 0x18, 0x25, 0x50, 0xed, 0x66, 0x8d, 0x49, 0x94, 0x1c, 0x4f, 0xef, 0x55, 0x02
                ],
                external_ovk: [
                    0x00, 0x96, 0xdd, 0xb9, 0xce, 0xa0, 0x3e, 0x17, 0xf2, 0x43, 0x0c, 0xe3, 0xf6, 0x1d, 0xf8, 0xcd, 0x43, 0x30, 0x94, 0x50, 0xf0, 0x1e, 0xfd, 0x6f, 0x5b, 0x33, 0xae, 0xc7, 0xac, 0xe1, 0x65, 0xbd
                ],
                internal_ovk: [
                    0x23, 0xb2, 0xef, 0x2b, 0x1e, 0xe4, 0x8a, 0xf6, 0x45, 0x9c, 0xe7, 0xf0, 0x61, 0x25, 0x14, 0x3d, 0xc9, 0x5c, 0xbe, 0x1e, 0xbf, 0x49, 0xd4, 0x11, 0xdb, 0x91, 0xe8, 0x8b, 0x59, 0x34, 0x14, 0x06
                ],
                account: 3,
            },
            TestVector {
                c: [
                    0x93, 0x4d, 0x5c, 0x7b, 0x67, 0xec, 0xeb, 0xc7, 0xfe, 0x71, 0x7f, 0xfb, 0xa0, 0x6f, 0x30, 0x97, 0x3e, 0xcd, 0xb4, 0x73, 0x5d, 0xd8, 0xc8, 0x17, 0x35, 0x28, 0xc3, 0x57, 0xec, 0x23, 0x31, 0x1f
                ],
                pk: [
                    0x03, 0x9e, 0xfd, 0xdc, 0x9c, 0xc1, 0xbf, 0x9f, 0x42, 0x14, 0xa0, 0x9a, 0x7f, 0x01, 0x88, 0x54, 0x07, 0x89, 0xb2, 0x61, 0x97, 0xcd, 0xed, 0xed, 0xc9, 0x93, 0xbe, 0x53, 0x81, 0x58, 0x7f, 0x79, 0xde
                ],
                address: [
                    0x1a, 0x8f, 0xaa, 0x82, 0xb6, 0xfe, 0x12, 0x85, 0x53, 0xc2, 0xf3, 0xf3, 0x8b, 0x22, 0x51, 0xd8, 0x88, 0x80, 0x48, 0xab
                ],
                external_ovk: [
                    0xed, 0x3e, 0xc5, 0xb6, 0x23, 0x27, 0x62, 0xb0, 0xda, 0x1b, 0x1c, 0xc4, 0xc6, 0x2e, 0x1e, 0x4f, 0x30, 0x29, 0x27, 0x40, 0x48, 0xe3, 0xf1, 0x80, 0x81, 0x46, 0x40, 0x1f, 0xc4, 0xd1, 0xf6, 0x1c
                ],
                internal_ovk: [
                    0x19, 0xd7, 0xd9, 0x37, 0xae, 0x9a, 0x49, 0xb1, 0xa5, 0x23, 0x7a, 0x06, 0xc5, 0xef, 0x3c, 0x7d, 0xa8, 0xde, 0x44, 0xe6, 0xcd, 0x64, 0x3b, 0xe3, 0xfd, 0xe7, 0x09, 0x14, 0x68, 0xcc, 0x24, 0x9c
                ],
                account: 4,
            },
            TestVector {
                c: [
                    0x03, 0xeb, 0x45, 0x2d, 0xae, 0x94, 0xc4, 0xee, 0xa9, 0x07, 0x7f, 0x24, 0x5d, 0x72, 0xb1, 0xa1, 0xe0, 0x8f, 0xa7, 0xd4, 0x96, 0x70, 0x2e, 0x6d, 0x45, 0xb9, 0xf5, 0xb3, 0xd4, 0x93, 0xb6, 0x94
                ],
                pk: [
                    0x03, 0xe0, 0x32, 0x02, 0x9b, 0xfe, 0x0a, 0xbd, 0xf0, 0x0e, 0x26, 0xee, 0xe7, 0x7e, 0x4c, 0x3b, 0x55, 0x67, 0x44, 0x86, 0xc9, 0x03, 0x42, 0x86, 0x48, 0xb2, 0x6a, 0xdb, 0x5c, 0x11, 0xce, 0xd5, 0xb3
                ],
                address: [
                    0xe5, 0x9b, 0x1c, 0x45, 0xcf, 0xda, 0x3f, 0x6f, 0x2d, 0xf7, 0x8d, 0x04, 0xbd, 0x0d, 0xf8, 0xa5, 0x93, 0x17, 0x88, 0x36
                ],
                external_ovk: [
                    0xc7, 0x3c, 0xd3, 0x90, 0xf8, 0xf4, 0x7d, 0xba, 0x4c, 0x87, 0x4c, 0x12, 0xc2, 0x23, 0xea, 0x47, 0x8e, 0x2b, 0x40, 0xc4, 0xfc, 0x8f, 0x5e, 0xcf, 0xc5, 0xa1, 0xda, 0x10, 0x38, 0xec, 0x45, 0x29
                ],
                internal_ovk: [
                    0x4b, 0x15, 0x90, 0x4c, 0x8c, 0x31, 0xea, 0x27, 0x22, 0x80, 0xeb, 0x75, 0xfb, 0xfa, 0x5e, 0xbd, 0xfa, 0x31, 0x60, 0x70, 0x83, 0xac, 0x56, 0x0d, 0x8f, 0x6e, 0x6e, 0xe3, 0x69, 0x0c, 0x00, 0xa4
                ],
                account: 5,
            },
            TestVector {
                c: [
                    0xde, 0xcf, 0x85, 0x43, 0x0d, 0xb4, 0x84, 0x89, 0xcd, 0xd8, 0x94, 0xaa, 0x29, 0xa7, 0x8b, 0x33, 0x15, 0xd2, 0x3b, 0xb6, 0x25, 0x88, 0x27, 0x57, 0xe3, 0x39, 0x6d, 0xf6, 0xe3, 0xba, 0xd6, 0xca
                ],
                pk: [
                    0x02, 0x8e, 0xfe, 0x8f, 0xa9, 0xb8, 0x82, 0x7f, 0x87, 0x48, 0x4a, 0xa1, 0x86, 0x87, 0x33, 0x72, 0xa4, 0x6e, 0x53, 0x8a, 0x1c, 0x3f, 0x34, 0x1a, 0xdb, 0x9c, 0x33, 0x69, 0xac, 0x4d, 0x4f, 0x70, 0x7a
                ],
                address: [
                    0x3a, 0x9c, 0x2a, 0xd9, 0x50, 0x09, 0x8f, 0x11, 0x1c, 0x3e, 0xdd, 0x0d, 0x3e, 0xb3, 0x09, 0x1c, 0x96, 0xea, 0x83, 0x56
                ],
                external_ovk: [
                    0x5c, 0x49, 0xa5, 0x6a, 0xdf, 0xff, 0x55, 0xb7, 0xfb, 0xa2, 0x8f, 0x52, 0xf2, 0x0e, 0x30, 0x64, 0xde, 0xdb, 0x2a, 0x65, 0xb3, 0x0f, 0x19, 0xf6, 0x8a, 0xed, 0x58, 0x89, 0xcd, 0xd7, 0xe4, 0x30
                ],
                internal_ovk: [
                    0x4d, 0x55, 0xd6, 0xdd, 0x28, 0x70, 0xc2, 0xf6, 0x29, 0x48, 0x68, 0x5d, 0x0e, 0x70, 0x27, 0x1a, 0x45, 0xe4, 0x90, 0xf6, 0xb8, 0xc3, 0x65, 0x02, 0x83, 0x5a, 0xbc, 0x92, 0xca, 0x92, 0x5f, 0xf3
                ],
                account: 6,
            },
            TestVector {
                c: [
                    0x69, 0x4c, 0xc0, 0x9d, 0xd2, 0x42, 0xe4, 0xa7, 0xb7, 0x4e, 0x3b, 0x3c, 0xd7, 0x95, 0xfe, 0x69, 0x59, 0xfa, 0x57, 0x7b, 0xa5, 0x6f, 0xde, 0xb5, 0xfc, 0xf4, 0xc1, 0xa4, 0x50, 0x2d, 0xec, 0x75
                ],
                pk: [
                    0x02, 0x14, 0x15, 0x8d, 0xc4, 0x63, 0x1f, 0x2a, 0x37, 0x84, 0xbf, 0xb4, 0x2b, 0x9a, 0xd4, 0x4d, 0xcb, 0x77, 0x9d, 0xcf, 0x0f, 0x26, 0xa1, 0xde, 0xf9, 0x12, 0x0f, 0x81, 0xc9, 0x83, 0x6b, 0xf4, 0xb5
                ],
                address: [
                    0x0f, 0xf6, 0xc3, 0xeb, 0xc6, 0x25, 0x38, 0xff, 0x1d, 0x69, 0x0d, 0xc8, 0xe0, 0x7a, 0x91, 0x3b, 0x15, 0xfe, 0xe1, 0xc5
                ],
                external_ovk: [
                    0xa2, 0x61, 0x04, 0x00, 0x35, 0x27, 0xbb, 0xf9, 0x39, 0xb6, 0x00, 0x26, 0xd7, 0x28, 0xd5, 0x6c, 0xda, 0xa5, 0xcd, 0xed, 0x07, 0x20, 0x9a, 0x2c, 0x62, 0xf8, 0x6d, 0xe7, 0x29, 0x86, 0x18, 0xad
                ],
                internal_ovk: [
                    0x91, 0x7f, 0x76, 0x7b, 0x53, 0x4b, 0xd8, 0x21, 0xb2, 0x46, 0x39, 0x86, 0x00, 0x49, 0xef, 0x4c, 0x8e, 0xf8, 0xa2, 0xec, 0xfb, 0x62, 0x91, 0xdc, 0x15, 0xa8, 0xbd, 0xa2, 0xf6, 0x5b, 0x8c, 0x23
                ],
                account: 7,
            },
            TestVector {
                c: [
                    0x3e, 0xea, 0x14, 0x08, 0xbf, 0xfa, 0x9c, 0x4c, 0x02, 0xdf, 0x5d, 0xd1, 0x74, 0xe8, 0xb5, 0x6e, 0x45, 0x06, 0xca, 0xad, 0xe7, 0x83, 0x92, 0x67, 0x76, 0x12, 0x27, 0xe4, 0xda, 0x25, 0x06, 0xa5
                ],
                pk: [
                    0x03, 0x5d, 0x0d, 0x72, 0x24, 0xc3, 0xbe, 0xb7, 0x8b, 0xc6, 0x7c, 0x21, 0x4f, 0x56, 0x73, 0x1b, 0x3f, 0xfb, 0x27, 0xb0, 0x63, 0x10, 0xa1, 0xe6, 0x09, 0x33, 0x84, 0xf6, 0xeb, 0x72, 0xb6, 0xc5, 0xf6
                ],
                address: [
                    0x9f, 0xf4, 0x3f, 0x3f, 0x01, 0x21, 0xbf, 0x05, 0x4c, 0x14, 0xea, 0x0d, 0x9d, 0x84, 0x9e, 0x0b, 0x02, 0xe9, 0x46, 0x87
                ],
                external_ovk: [
                    0x7a, 0xa8, 0xb1, 0xf6, 0x6d, 0xa9, 0xfe, 0xbf, 0x1a, 0x8c, 0xa9, 0x2f, 0xaa, 0x4b, 0x3f, 0x83, 0x8a, 0xb4, 0x50, 0x3e, 0xa4, 0x18, 0x3d, 0xcf, 0x05, 0xf6, 0x7c, 0x1b, 0x13, 0x58, 0x79, 0x10
                ],
                internal_ovk: [
                    0x77, 0xd1, 0x93, 0x54, 0xbd, 0xc0, 0xea, 0xf3, 0xb4, 0x00, 0x65, 0xb9, 0xc7, 0xfa, 0xc8, 0xc2, 0xf7, 0x04, 0x08, 0x17, 0x74, 0xab, 0xde, 0x2d, 0x15, 0x13, 0x1f, 0x80, 0x96, 0x4d, 0x76, 0xfd
                ],
                account: 8,
            },
            TestVector {
                c: [
                    0xb6, 0x08, 0x95, 0x76, 0x6b, 0xda, 0xd0, 0x50, 0xed, 0x93, 0x2d, 0x00, 0x99, 0x83, 0x22, 0x55, 0xdc, 0x09, 0x66, 0xea, 0xb8, 0xf9, 0x8a, 0x3b, 0x15, 0x77, 0xf4, 0x50, 0xf2, 0x26, 0xa9, 0x41
                ],
                pk: [
                    0x02, 0x95, 0x59, 0x9f, 0xc0, 0x48, 0xf2, 0x18, 0x11, 0x56, 0xf9, 0xe4, 0x53, 0x73, 0x5d, 0x98, 0x9e, 0xb6, 0x16, 0x23, 0xf6, 0xee, 0xe8, 0xa0, 0x60, 0xb8, 0xf3, 0xfa, 0x59, 0x66, 0x6c, 0xdf, 0xe1
                ],
                address: [
                    0xda, 0xeb, 0xdd, 0x95, 0x7b, 0xe5, 0x47, 0x02, 0xdb, 0x56, 0xdd, 0x0d, 0x1c, 0x19, 0xa7, 0x76, 0x06, 0xdf, 0xec, 0xd5
                ],
                external_ovk: [
                    0xa5, 0x30, 0x77, 0x62, 0x06, 0x17, 0xc1, 0xd1, 0xce, 0xad, 0xa1, 0x21, 0x2e, 0xe5, 0x48, 0x3e, 0x1c, 0xd3, 0x10, 0x34, 0x82, 0x1c, 0x59, 0x8c, 0x04, 0x90, 0xe8, 0x97, 0xa9, 0x60, 0xe8, 0xcb
                ],
                internal_ovk: [
                    0x48, 0x16, 0x20, 0x80, 0xf8, 0x57, 0x4d, 0x87, 0xab, 0x71, 0x41, 0x45, 0x06, 0x46, 0xe2, 0x83, 0x79, 0x17, 0xdf, 0xd8, 0x38, 0xda, 0xac, 0x0b, 0x59, 0x32, 0xd1, 0x56, 0xdc, 0xec, 0xbb, 0x2f
                ],
                account: 9,
            },
        ];
